"use strict";

/* eslint-disable no-param-reassign */
var updateSelectors = function updateSelectors(lang) {
  document.querySelectorAll(".code-selector").forEach(function (selector) {
    var langSelect = selector.querySelector(".code-selector-select-" + lang);
    var langCode = selector.querySelector(".code-selector-code-" + lang);

    if (langSelect && langCode) {
      selector.querySelectorAll(".code-selector-toolbar button").forEach(function (select) {
        select.classList.remove("selected");
      });
      selector.querySelectorAll("[class^=code-selector-code-]").forEach(function (code) {
        code.style.display = "none";
      });
      langSelect.classList.add("selected");
      langCode.style.display = "block";
    }
  });
};

var setLang = function setLang(lang) {
  localStorage.setItem("selectedLang", lang);
  updateSelectors(lang);
};

exports.onRouteUpdate = function () {
  document.querySelectorAll(".code-selector-toolbar button").forEach(function (select) {
    return select.addEventListener("click", function (event) {
      return setLang(event.target.textContent);
    });
  });
  var selectedLang = localStorage.getItem("selectedLang");

  if (selectedLang) {
    updateSelectors(selectedLang);
  }
};