"use strict";

/* eslint-disable no-param-reassign */

/* eslint-disable no-console */
var visit = require("unist-util-visit");

var remarkMacro = require("remark-macro")();

remarkMacro.addMacro("codeSelector", function (content, props, _ref) {
  var transformer = _ref.transformer,
      eat = _ref.eat;
  return {
    type: "CodeSelectorNode",
    children: transformer.tokenizeBlock(content, eat.now())
  };
});

module.exports = function (_ref2) {
  var markdownAST = _ref2.markdownAST;
  visit(markdownAST, "CodeSelectorNode", function (node) {
    var html = "";
    var toolbarHtml = "";
    var firstCodeNode = true;
    node.children.forEach(function (codeNode) {
      if (codeNode.type === "code") {
        console.warn("code inside [codeSelector] has not been parsed yet, have you defined `gatsby-remark-code-selector` after `gatsby-remark-prismjs`?");
        return;
      }

      if (codeNode.type !== "html" || !codeNode.lang) {
        console.warn("content inside [codeSelector] should only be parsed code, received:\n", codeNode);
        return;
      }

      html += "<div class=\"code-selector-code-" + codeNode.lang + "\" style=\"" + (firstCodeNode ? "" : "display: none") + "\">" + codeNode.value + "</div>";
      toolbarHtml += "<button type=\"button\" class=\"code-selector-select-" + codeNode.lang + " " + (firstCodeNode ? "selected" : "") + "\">" + codeNode.lang + "</button>";
      firstCodeNode = false;
    });
    node.type = "html";
    node.children = undefined;
    node.value = "\n      <div class=\"code-selector\">\n          <div class=\"code-selector-toolbar\">\n              " + toolbarHtml + "\n          </div>\n          " + html + "\n      </div>\n    ";
  });
  return markdownAST;
};

module.exports.setParserPlugins = function () {
  return [remarkMacro.transformer];
};